//CRC Module

module CRC(
					packet_in,
					packet_ready_in,
					crc_result_out,
					reset,
					crc_out
					);
					
output wire crc_result_out;
input wire [79:0] packet_in;
input wire packet_ready_in;
input wire reset;
 
wire [7:0] xor_result;
output wire [7:0] crc_out;
wire one_true;

assign xor_result =
										packet_in[79:72]   ^ packet_in[71:64]   ^ packet_in[63:56] ^
										packet_in[55:48]   ^ packet_in[47:40]   ^ packet_in[39:32] ^
										packet_in[31:24]   ^ packet_in[23:16]   ^ packet_in[15:8];



assign one_true = (xor_result == packet_in[7:0]) ? 1'b1 : 1'b0;

										
assign crc_result_out = one_true /*& two_true*/ & ~reset;
assign crc_out = xor_result;




endmodule
