//Peter Greczner - Simple Instruction RAM

module SimpleIRAM(clock, write, instr_in, pc, pc_write, instr_out, isDraw, reset);

input wire clock, write, reset;
output wire isDraw;

input wire [11:0] pc, pc_write;

input wire [79:0] instr_in;
output reg [79:0] instr_out;

assign isDraw = (instr_out[79] == 1'b1) ? 0 : 1;

reg [79:0] instr_list [0:1024];

always @(pc)
begin
	instr_out <= instr_list[pc[9:0]];
end

always @(posedge clock)
begin
	if(write) begin
		instr_list[pc[9:0]] <= instr_in;
	end
end

endmodule

