module XAddr_MUX(
					xCF, xCD, xSD, xSF, xLD, xTW, xIDLE,
					clock, select, 
					xOut


);

input wire [9:0] xCF, xCD, xSD, xSF, xLD, xTW, xIDLE;
input wire clock;
input wire [3:0] select;
output wire [9:0] xOut;
reg [9:0] xReg;
assign xOut = xReg;

parameter 	[3:0] 	circle_fill = 4'd0,
					circle_draw = 4'd1,
					square_fill = 4'd2,
					square_draw = 4'd3,
					line_draw = 4'd4,
					text_write = 4'd5,
					frame_update = 4'd6,
					idle = 4'd15;


always @(posedge clock) begin
	case(select)
		circle_fill: begin xReg <= xCF; end
		circle_draw: begin xReg <= xCD; end
		square_fill: begin xReg <= xSF; end
		square_draw: begin xReg <= xSD; end
		line_draw: begin xReg <= xLD; end
		text_write: begin xReg <= xTW; end
		idle: begin xReg <= xIDLE; end
		default: begin
			xReg <= 0;
		end
	endcase
end

endmodule

