module YAddr_MUX(
					yCF, yCD, ySD, ySF, yLD, yTW, yIDLE,
					clock, select, 
					yOut


);

input wire [8:0] yCF, yCD, ySD, ySF, yLD, yTW, yIDLE;
input wire clock;
input wire [3:0] select;
output wire [8:0] yOut;
reg [8:0] yReg;
assign yOut = yReg;

parameter 	[3:0] 	circle_fill = 4'd0,
					circle_draw = 4'd1,
					square_fill = 4'd2,
					square_draw = 4'd3,
					line_draw = 4'd4,
					text_write = 4'd5,
					frame_update = 4'd6,
					idle = 4'd15;


always @(posedge clock) begin
	case(select)
		circle_fill: begin yReg <= yCF; end
		circle_draw: begin yReg <= yCD; end
		square_fill: begin yReg <= ySF; end
		square_draw: begin yReg <= ySD; end
		line_draw: begin yReg <= yLD; end
		text_write: begin yReg <= yTW; end
		idle: begin yReg <= yIDLE; end
		default: begin
			yReg <= 0;
		end
	endcase
end

endmodule

